<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetOnsiteWrapUpStatusOutput StructType
 * @subpackage Structs
 */
class GetOnsiteWrapUpStatusOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The IsComplete
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsComplete;
    /**
     * The CompletionDateUtc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $CompletionDateUtc;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The Results
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult
     */
    public $Results;
    /**
     * Constructor method for GetOnsiteWrapUpStatusOutput
     * @uses GetOnsiteWrapUpStatusOutput::setSuccess()
     * @uses GetOnsiteWrapUpStatusOutput::setIsComplete()
     * @uses GetOnsiteWrapUpStatusOutput::setCompletionDateUtc()
     * @uses GetOnsiteWrapUpStatusOutput::setErrorMessage()
     * @uses GetOnsiteWrapUpStatusOutput::setResults()
     * @param bool $success
     * @param bool $isComplete
     * @param string $completionDateUtc
     * @param string $errorMessage
     * @param \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult $results
     */
    public function __construct($success = null, $isComplete = null, $completionDateUtc = null, $errorMessage = null, \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult $results = null)
    {
        $this
            ->setSuccess($success)
            ->setIsComplete($isComplete)
            ->setCompletionDateUtc($completionDateUtc)
            ->setErrorMessage($errorMessage)
            ->setResults($results);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get IsComplete value
     * @return bool
     */
    public function getIsComplete()
    {
        return $this->IsComplete;
    }
    /**
     * Set IsComplete value
     * @param bool $isComplete
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public function setIsComplete($isComplete = null)
    {
        // validation for constraint: boolean
        if (!is_null($isComplete) && !is_bool($isComplete)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isComplete, true), gettype($isComplete)), __LINE__);
        }
        $this->IsComplete = $isComplete;
        return $this;
    }
    /**
     * Get CompletionDateUtc value
     * @return string
     */
    public function getCompletionDateUtc()
    {
        return $this->CompletionDateUtc;
    }
    /**
     * Set CompletionDateUtc value
     * @param string $completionDateUtc
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public function setCompletionDateUtc($completionDateUtc = null)
    {
        // validation for constraint: string
        if (!is_null($completionDateUtc) && !is_string($completionDateUtc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($completionDateUtc, true), gettype($completionDateUtc)), __LINE__);
        }
        $this->CompletionDateUtc = $completionDateUtc;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get Results value
     * @return \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult|null
     */
    public function getResults()
    {
        return $this->Results;
    }
    /**
     * Set Results value
     * @param \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult $results
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public function setResults(\CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult $results = null)
    {
        $this->Results = $results;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\GetOnsiteWrapUpStatusOutput
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
